! ---------------------------------------------------------------------------
! L_tL_parallel_test16_off_1sum_openmp.f90 - by Alejandro Valenciano 
!                        
!           SEptember  2005.
! ---------------------------------------------------------------------------
!  Parameters: 
!              nax     x offset from the diagonal  (odd)
!              naz     z offset from the diagonal  (odd)
!              noff    x subsurfase offset  
!         I/O:
!              in      green_in function (nx,nz,nsx) 
!              out     Hessian           (naz,nax,noff,nz,nx,noff) 
!                          
! Description: 
!              Computes the Hessian 
!              Parallelizable in the omega dimension
! ---------------------------------------------------------------------------

program L_tL_para 
use sep
use omp_lib
use omp_sector

implicit none

integer                                    :: n1,n2,n3,n4,esize
real                                       :: o1,o2,o3,o4
real                                       :: d1,d2,d3,d4 
integer                                    :: nsx,nz,nx,nw,nax,naz,noff,naz2,nax2,nxd,ix,iz,isr,iw,i1,ioff,idata
real                                       :: mini,maxi,minid,maxid,start,xdata
complex, dimension(:,:,:)    , allocatable :: green,green_input
real   , dimension(:)        , allocatable :: auxi
real,    dimension(:,:,:,:,:), allocatable :: LtL,auxi2 
integer, external                          :: srite,sreed
logical                                    :: add
integer                                    :: time_array_0(8), time_array_1(8)
real                                       :: finish_timet, start_timet

call sep_init()
call set_no_putch()

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call from_param('nax',nax,11)        ! allways odd 
call from_param('naz',naz,11)        ! allways odd
call from_param('noff',noff,1)  
call from_param('mini',mini,-999999999.)  
call from_param('nx',nx,-999999999)  
     
! Parameters calculation out of the loop
minid=o3+o1
nxd=1.5+((n3-1)*d3+(n1-1)*d1)/d1                
if (nx  ==-999999999) nx   = nxd
if (mini==-999999999.) then 
   mini = minid
end if
maxi = mini + (nx-1)*d1
nsx=n3
nz=n2
nw=n4
naz2=(naz-1)/2
nax2=(nax-1)/2

!check to see if this is the first time we are writing to the file----------------------------------------------------
call from_param("add",add,.false.)
if (.not. add) then
  call to_history('n1',naz,"outtag") ;  call to_history('d1',d2,"outtag")
  call to_history('o1',0.,"outtag")  ;  call to_history('label1',"az","outtag")
  call to_history('n2',nax,"outtag") ;  call to_history('d2',d1,"outtag"); 
  call to_history('o2',0.,"outtag" ) ;  call to_history('label2',"ax","outtag")
  call to_history('n3',noff,"outtag");  call to_history('d3',d1,"outtag"); 
  call to_history('o3',0.,"outtag")  ;  call to_history('label3',"h1","outtag")
  call to_history('n4',nz,"outtag")  ;  call to_history('d4',d2,"outtag"); 
  call to_history('o4',o2,"outtag")  ;  call to_history('label4',"z","outtag")
  call to_history('n5',nx,"outtag")  ;  call to_history('d5',d1,"outtag"); 
  call to_history('o5',mini,"outtag");  call to_history('label5',"mx","outtag")
  call to_history('n6',noff,"outtag");  call to_history('d6',d1,"outtag"); 
  call to_history('o6',0.,"outtag")  ;  call to_history('label6',"h","outtag")
  call to_history('n7',nw,"outtag")  ;  call to_history('d7',d4,"outtag"); 
  call to_history('o7',o4,"outtag")  ;  call to_history('label7',"w","outtag")
  call to_history('esize',4)
  do ioff=1,noff
    allocate(auxi(naz*nax*noff*nz*nx))
    auxi=0.
    if (srite("outtag",auxi,4*nz*noff*nx*naz*nax) /= 4*nz*noff*nx*naz*nax) &
      call seperr("Error writing data")
    deallocate(auxi)
  enddo
  call auxclose("outtag")
end if
call auxinout("outtag")
!---------------------------------------------------------------------------------------------------------------------
call sep_begin_prog()

write(0,*)"nsx,nz,nx,nw",nsx,nz,nx,nw
write(0,*)"d1,d2,d3,d4",d1,d2,d3,n4
write(0,*)"o1,o2,o3,o4",o1,o2,o3,n4
!----------------------------------------------------------------------------------------------------------------------
allocate(green(nsx,nz,nx),LtL(naz,nax,noff,nz,nx),auxi2(naz,nax,noff,nz,nx)) 
write(0,*)"allocated memory green_input",n1*nz*nsx*8
write(0,*)"allocated memory green",nsx*nz*nx*8
write(0,*)"allocated memory LtL",nz*noff*nx*naz*nax*4
write(0,*)"allocated memory auxi2",nz*noff*nx*naz*nax*4
write(0,*)"allocated memory aaa",4*nsx*8
write(0,*)"allocated memory",n1*nz*nsx*8+nsx*nz*nx*8+2*nz*nx*naz*noff*nax*4+2*nsx*8
!----------------------------------------------------------------------------------------------------------------------
call date_and_time(values=time_array_0)
start_timet = time_array_0 (3) * 86400.+ time_array_0 (5) * 3600  + time_array_0 (6) * 60 &
           + time_array_0 (7) + 0.001 * time_array_0 (8)
!----------------------------------------------------------------------------------------------------------------------
do iw=1,nw
  write(0,*)"frequency",iw
  allocate(green_input(n1,nz,nsx))
  call sep_read(green_input)
  green=(0.,0.)
  do isr=1,nsx
  do iz=1,nz
  do i1=1,n1    
    xdata=o3+(isr-1)*d3+o1+(i1-1)*d1                                                        
    if ((xdata >= mini) .and. (xdata <= maxi)) then 
      idata=1.5+(xdata-mini)/d1
      green(isr,iz,idata)=green_input(i1,iz,isr)
    endif
  end do
  end do
  end do
  deallocate(green_input)

  do ioff=1,noff
   LtL=0.;
   !$omp parallel do private(ix)
   do ix=1,nx
     call omp_do (nx,nsx,nz,noff,nax,naz,naz2,nax2,ix,ioff,green,LtL)
   enddo  
   !$omp end parallel do
   !---------------------------------------------------------------------------------------------------------------------
   call sep_open_lock("outtag")  !make sure only one process at a time writes
   call sseek("outtag",(ioff-1)*esize*nz*noff*nx*naz*nax/2,0)
   if (sreed("outtag",auxi2,esize*nz*noff*nx*naz*nax/2) /= esize*nz*noff*nx*naz*nax/2) &
      call seperr("Error reading data")
   LtL= LtL+auxi2
   call sseek("outtag",0,0)
   call sseek("outtag",(ioff-1)*esize*nz*noff*nx*naz*nax/2,0)
   if (srite("outtag",LtL,esize*nz*noff*nx*naz*nax/2) /= esize*nz*noff*nx*naz*nax/2) &
      call seperr("Error writing data")
   call sep_close_lock("outtag") !allow other processes to write
   !---------------------------------------------------------------------------------------------------------------------
  enddo
enddo

!----------------------------------------------------------------------------------------------------------------------
call date_and_time(values=time_array_1)
finish_timet = time_array_0 (3) * 86400.+ time_array_1 (5) * 3600  + time_array_1 (6) * 60 &
            + time_array_1 (7) + 0.001 * time_array_1 (8)
write(0,*)'total time', finish_timet - start_timet
!----------------------------------------------------------------------------------------------------------------------

deallocate(green,LtL,auxi2)

call sep_end_prog()

end program L_tL_para
