include ${SEPINC}/SEP.top
#LATOPTS = option=web 'style=jfc,makeidx,html,amsmath'
BINDIR = ./Bin/${MTYPE}
OBJDIR = ./Obj/${MTYPE}
SRCDIR = ./Src
RESDIR = ./Fig
PARDIR = ./Par
TXTDIR = ./Txt

RESULTSCR = Sis_vel mig_Sis hesian_phase_Sis comp_Sis_full comp_Sis_wind 

UF90FLAGS = -O3 -axP  -static-libcxa
UF90LIBS= -lsepgeef90 -lsep2df90  

data_over_f.H:
	< ${SIGSMULT_DATA}/sigsbee2b_nfs_shot.H Window3d max_memory=1000 max3=60000 |Mute vmute=4920 tmute=2 > t1$@
	< t1$@ Transf wei=y  f_min=5 f_min1=10 f_max1=30 f_max=35 maxsize=1000> t2$@
	< t2$@ Window3d max_memory=1000 n5=360 | Transp plane=24 maxmem=1000 > t3$@
	< t3$@ Window3d |Interp maxsize=2000  d3out=75 > t4$@
	< t4$@ Mute vmute=4920 tmute=2 | Pad beg2=300 > t5$@
	< t5$@ Transf wei=y  f_min=5 f_min1=10 f_max1=30 f_max=35 maxsize=1000>t6$@
	< t6$@ Window3d max_memory=1000 n5=360 | Transp plane=24 maxmem=1000 > $@
	Rm t*$@

wave_over.H:
	Wavelet n1=1024 o1=0 d1=0.011719 domain=time fund=20 wavelet=ricker2 > t1$@
	Add scale=-1 t1$@ > t2$@
	< t2$@ Transf wei=y f_min=5 f_min1=10 f_max1=30 f_max=35 maxsize=1000  >t3$@
	< t3$@ Window3d n5=360 squeeze=n | Transp maxmem=500 plane=35 > $@
	Rm t*$@

mig_Sis_Parallel_16000.H green_Sis_16000.H: vel.zig.HH data_over_f.H wave_over.H ${BINDIR}/Wedge.x ${BINDIR}/sp_serial.x ${PARDIR}/go_sis.P
	< vel.zig.HH Window3d n1=701 |Pad beg2=1000 extend=1|Transp> vel_pad.H
	${BINDIR}/Wedge.x vel_pad.H axis=2 nn=1 no=0. nd=75. 
	echo  "  label1="x" label2="y" label3="z" " >> vel_pad.H
	@date
	Parallel command=${BINDIR}/sp_serial.x  files="data_over_f.H,wave_over.H,vel_pad.H,green_Sis_16000.H,$@"  \
	tags="D,D_d,S,W_d,R" usage="INPUT,INPUT,INPUT,OUTPUT,OUTPUT" nblock=653 axis=4,5,5,5,6 pverb=2 device=eth0 \
	file_type="DISTRIBUTE,COPY,COPY,DISTRIBUTE,DISTRIBUTE"  mach_mfile=mfile_big \
	par=${PARDIR}/go_sis.P firstzW=640 #restart=y

mig_Sis_Parallel_16000_s150_merge_stack.H: mig_Sis_Parallel_16000.H  \
	 ${BINDIR}/Pad_mx_nosym.x ${BINDIR}/stack_5d.x
	< mig_Sis_Parallel_16000.H ${BINDIR}/Pad_mx_nosym.x | ${BINDIR}/stack_5d.x > $@

LtL_Sis_parall_az21_ax7_off_1sum_full.H: ${BINDIR}/L_tL_parallel_test16_off_1sum_openmp.x green_Sis_16000.H
	date
	Window3d < green_Sis_16000.H max_memory=1000| Transp plane=23 max_memory=1000 reshape=1,2,4,5,6 > pp1.H
	Parallel par=conv_off_1sum.P  files="pp1.H,$@" file_type="DISTRIBUTE,COPY" nax=7 \
	 naz=21 noff=1 mini=24000. nx=430 mach_mfile=mfile_big_1p #restart=y
	date
	Rm  pp1.H
#----------------------------------------------------------
inv_Sis_az21_ax7full_%.H: ${BINDIR}/Sparse_Mxv_inv.x mig_Sis_Parallel_16000_s150_merge_stack.H LtL_Sis_parall_az21_ax7_off_1sum_full.H
	Window3d < mig_Sis_Parallel_16000_s150_merge_stack.H min2=16000 min1=24050 n1=429| Transp | Scale scale_to=1. > pp.H
	Window3d < LtL_Sis_parall_az21_ax7_off_1sum_full.H min5=24050| Transp plane=12 reshape=2,4 | Scale scale_to=1.> pp1.H
	< pp1.H ${BINDIR}/Sparse_Mxv_inv.x mig=pp.H  niter=$* eps=1.5 alpha=.001 na=1  remov=rmov.H mmov=mmov.H wmov=wmov.H>$@
	Rm pp*.H

inv_Sis_az21_ax733000_%.H: ${BINDIR}/Sparse_Mxv_inv.x
	Window3d < mig_Sis_Parallel_16000_s150_merge_stack.H min2=16000 min1=33000 n1=303| Transp | Scale scale_to=1. > pp.H
	Window3d < LtL_Sis_parall_az21_ax7_off_1sum_full.H min5=33000 n5=303| Transp plane=12 reshape=2,4 | Scale scale_to=1.> pp1.H
	< pp1.H ${BINDIR}/Sparse_Mxv_inv.x mig=pp.H  niter=$* eps=1.5 alpha=.001 na=1  remov=rmov.H mmov=mmov.H wmov=wmov.H>$@
	Rm pp*.H
#----------------------------------------------------------


GREYP= Grey pclip=100 label1="az (ft)" label2="ax (ft)" label3=" " labelsz=12 titlesz=12 crowd2=.7  \
	    grid=y > /dev/null
GREYS= Grey pclip=100 label1="z (ft) " label2="x (ft)" label3=" "  labelsz=8 title=" " \
		o1num=16000 d1num=1000 d2num=6000  title=" "  > /dev/null \
		labelsz=14 titlesz=14  crowd1=.7  crowd2=.6
GREYC2= Grey   pclip=100 label1="z (ft) " label2="x (ft)" label3=" "  \
	    o1num=16000 d1num=1000 d2num=6000  title=" " > /dev/null \
		labelsz=14 titlesz=14  crowd1=.7  crowd2=.6 
GREYV2= Grey allpos=y  pclip=100 label1="z (ft) " label2="x (ft)" label3="velociy ft/s" labelsz=8 titlesz=8 \
	    wantscalebar=y  crowd1=.75  crowd2=.75 bias=4920 title=" "  > /dev/null

 
${RESDIR}/Sis_vel.v:
	< /scr1/alejandro/sigsbee_multiple/sigsbee2b_migration_velocity.H Window> j.H
	echo "hff=-1 gff=-1 d1=25 o2=10025 d2=37.5"      >>j.H
	Window3d < j.H  min2=10925 max2=65000 min1=6000 max1=17525| ${GREYV2}  out=pp.v 
	< pp.v vp_annotate batch=y text=${TXTDIR}/text_Sis  | vppen vpstyle=n   > $@
	Rm j.H; \rm pp.v 

HESSIAN=/net/koko/homes/sep/alejandro/research/Hessian_winter

${RESDIR}/hesian_phase_Sis.v: 
	Cp ${HESSIAN}/H12.H	LtL_1.H
	echo o1=-250 o2=-250 >> LtL_1.H
	Window3d n4=1 min4=17000 n5=1 min5=30000   < LtL_1.H | ${GREYP} title="(a)"    out=1.v
	Window3d n4=1 min4=17000 n5=1 min5=34000   < LtL_1.H | ${GREYP} title="(b)"    out=2.v
	Window3d n4=1 min4=17000 n5=1 min5=38000   < LtL_1.H | ${GREYP} title="(c)"  out=3.v
	Window3d n4=1 min4=17000 n5=1 min5=42000   < LtL_1.H | ${GREYP} title="(d)"   out=4.v
	vp_SideBySideAniso 1.v 2.v | vppen vpstyle=n txscale=1.8 tyscale=1.8 > top.v
	vp_SideBySideAniso 3.v 4.v | vppen vpstyle=n txscale=1.8 tyscale=1.8 > bot.v
	vp_OverUnderAniso top.v bot.v > $@
	\rm 1.v 2.v 3.v 4.v  top.v bot.v


${RESDIR}/mig_Sis.v:
	Window3d < ${HESSIAN}/mig_Sis_Parallel_16000_s150_merge_stack.H min1=10925 max1=65000 min2=6000 | Transp | ${GREYS} pclip=97 out=$@ > /dev/null

${RESDIR}/mig_Sis_wind.v: 
	Window3d < ${HESSIAN}/mig_Sis_Parallel_16000_s150_merge_stack.H min1=32975 n1=303 min2=16000 n2=62 | Transp | Grey pclip=99.9  out=$@ > /dev/null


${RESDIR}/comp_Sis_wind.v:
	Window3d f1=10 n1=1 f2=3 n2=1 <  ${HESSIAN}/H12.H min5=32975| ${GREYC2}  pclip=100 out=0.v  allpos=y title="(a)"
	Window3d < ${HESSIAN}/mig_Sis_Parallel_16000_s150_merge_stack.H min1=32975 n1=303 min2=16000 n2=62  | Transp | ${GREYS}  pclip=99.9   out=1.v title="(b)"
	Window3d < ${HESSIAN}/../NoStaDecon/inv_Sis_az21_ax7full_100.H min2=32975 n2=303 |${GREYS}  pclip=99.9  out=02.v title="(c)"
	Window3d < ${HESSIAN}/../NoStaDecon/inv_Sis_az21_ax733000_100.H | ${GREYS} pclip=99.9  out=2.v title="(d)"
	vp_OverUnderAniso 0.v 1.v 02.v 2.v|  vppen vpstyle=n > $@

${RESDIR}/comp_Sis_full.v:
	< /scr1/alejandro/sigsbee_multiple/sigsbee2b_stratigraphy.H Window> js.H
	echo "hff=-1 gff=-1 d1=25 o2=10025 d2=25"      >>js.H
	Window3d < js.H  min2=24050 n2=1257 min1=16000 n1=62| ${GREYC2}  out=0.v  allpos=y bias=6000 title="(a)"
	Window3d f1=10 n1=1 f2=3 n2=1 <  ${HESSIAN}/H12.H| ${GREYC2} pclip=100 out=00.v  allpos=y title="(b)"
	Window3d < ${HESSIAN}/mig_Sis_Parallel_16000_s150_merge_stack.H min1=24050 n1=419 min2=16000 n2=62  | Transp | ${GREYS} pclip=99.9   out=1.v title="(c)"
	Window3d < ${HESSIAN}/../NoStaDecon/inv_Sis_az21_ax7full_100.H | ${GREYS} pclip=99.9  out=2.v title="(d)"
	vp_OverUnderAniso 0.v 00.v 1.v 2.v|  vppen vpstyle=n > $@

clean: jclean
	rm -f ./*.stb ./*fix*
	rm -f ./Obj/LINUX/*.o ./Obj/SGI64/*.o
	rm -f ./Bin/LINUX/*.x ./Bin/SGI64/*.x
	rm -f ./Lib/LINUX/* ./Lib/SGI64/*
	rm -f ./Src/*.o ./Src/*.stb ./Src/*.mod ./Src/*fix*

include ${SEPINC}/SEP.bottom
